<template>
  <div class="q-pa-md">
    <div class="row">
    <q-card class="full-width" flat bordered>
      <q-card-section align="center">
        <RaspberryPiVideo />
        <q-card-actions vertical class="justify-around q-px-md">
          <q-btn
            class="btn"
            size="lg"
            @click="switchDrivingMode"
            :color="drivingModeButtonColor"
          >
            {{ drivingModeButtonText }}
          </q-btn>

          <q-btn
            class="btn"
            size="lg"
            @click="switchRecordingState"
            :color="recordingButtonColor"
            v-if="!serviceStatus?.self_driving"
          >
            {{ recordingButtonText }}
          </q-btn>

          <q-btn
            class="btn"
            @click="showNerdStats = !showNerdStats"
            color="green-2"
          >
            Nerdstats anzeigen/Debug Info
          </q-btn>
        </q-card-actions>
      </q-card-section>
    </q-card>
    </div>

    <q-dialog v-model="showNerdStats">
      <q-card>
        <q-card-section>
          <div class="text-h6">Nerdstats</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <q-list bordered>
            <q-item clickable v-ripple v-for="(value, key) in serviceStatus" :key="key">
              <q-item-section>{{ key }}</q-item-section>
              <q-item-section avatar>
                {{ value }}
              </q-item-section>
            </q-item>
          </q-list>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <q-list bordered>
            <q-item clickable v-ripple v-for="(value, key) in vehicleStats" :key="key">
              <q-item-section>{{ key }}</q-item-section>
              <q-item-section avatar>
                {{ value }}
              </q-item-section>
            </q-item>
          </q-list>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Schliessen" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
</div>
</template>
<script setup lang="ts">
import { ref, toRefs, computed } from 'vue';
import RaspberryPiVideo from 'components/vehicle/RaspberryPiVideo.vue';
import { useApiStore } from 'stores/api-store';

const showNerdStats = ref(false);

const apiStore = useApiStore();

const { serviceStatus, vehicleStats } = toRefs(apiStore.$state);

const switchRecordingState = async () => {
  await apiStore.switchRecordingState();
};

const recordingButtonColor = computed(() => {
  if (serviceStatus.value?.is_recording) {
    return 'negative';
  }
  return 'positive';
});

const recordingButtonText = computed(() => {
  if (serviceStatus.value?.is_recording) {
    return 'Aufnahme Stoppen';
  }
  return 'Aufnahme Starten';
});

const drivingModeButtonColor = computed(() => {
  if (serviceStatus.value?.self_driving) {
    return 'accent';
  }
  return 'secondary';
});

const drivingModeButtonText = computed(() => {
  if (serviceStatus.value?.self_driving) {
    return 'Notstopp/an Fernsteuerung abgeben';
  }
  return 'Selbstfahren aktivieren';
});

const switchDrivingMode = async () => {
  await apiStore.switchDrivingMode();
};

</script>
